/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- cpustate.h								--
--                                                                      --
--	CPU save state data structure and fn prototypes			--
--                                                                      --
--	Author:  PAB/JGS 24/10/89					--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: %W% %G% Copyright (C) 1987, Perihelion Software Ltd.	*/
/* RcsId: $Id: cpustate.h,v 1.2 90/09/26 17:30:27 paul Exp $ */

#ifndef __cpustate_h
#define __cpustate_h

#ifndef __helios_h
#include <helios.h>
#endif

#ifdef __HELIOSARM
/* This should be be kept in-line with the TRUE definition in
 * "/helios/include/hobjasm/arm.s"
 */
#define sl_offset	(0x00000080)

/* This structure should be be kept in-line with the TRUE definition in
 * "/helios/include/hobjasm/exstruct.s"
 */
typedef struct SaveState {
	struct SaveState	*next ;		/* NULL (used by scheduler) */
	word			endtime ;	/* NULL (used by scheduler) */
	word			pri ;
        word			fparea ;	/* fp work area */
	word			initial_dp ;	/* dp given to CreateProcess */
	word			a1 ;		/* argument variables */
	word			a2 ;
	word			a3 ;
	word			a4 ;
	word			v1 ;		/* register variables */
	word			v2 ;
	word			v3 ;
	word			v4 ;
	word			v5 ;
	word			dp ;		/* module table pointer */
	word			sl ;		/* stack limit */
	word			fp ;		/* frame pointer */
	word			ip ;		/* temporary register */
	word			sp ;		/* stack pointer */
	word			lk ;		/* link register */
	word			pc ;		/* program counter */
} SaveState;
#else
#error "Processor specific SaveState structure not defined"
#endif

typedef struct ProcessQ {
	SaveState *head;
	SaveState *tail;
} ProcessQ;

extern word SaveCPUState(SaveState *cpustate);
extern void RestoreCPUState(SaveState *cpustate);


#endif

/* -- End of cpustate.h */

