/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   C   L I B R A R Y			--
--                     -------------------------------                  --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- nonansi.h								--
--                                                                      --
--	Helios extensions to the ANSI library				--
--                                                                      --
--	Author:  BLV 9/5/88						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: %W% %G% Copyright (C) 1987, Perihelion Software Ltd.	*/
/* $Id: nonansi.h,v 1.1 90/09/05 11:06:56 nick Exp Locker: nick $ */

#ifndef __nonansi_h
#define __nonansi_h

#ifndef __syslib_h
#include <syslib.h>
#endif
#ifndef __memory_h
#include <memory.h>
#endif
#ifndef __stdio_h
#include <stdio.h>
#endif

void *NewProcess(WORD stacksize, VoidFnPtr function, WORD argsize);
void ExecProcess(void *process, word logpri);
void RunProcess(void *process);
void ZapProcess(void *process);
word Fork(WORD stacksize, VoidFnPtr function, WORD argsize, ...);
word _cputime(void);
void StackCheck(void);
void IOdebug(const char *fmt, ...);
void IOputc(char c);
void IOputs(char *s);
#ifndef __HELIOSARM
void Accelerate(Carrier *fastram, VoidFnPtr function, WORD argsize, ...);
word AccelerateCode(VoidFnPtr function);
void bytblt(	char *source,	char *dest, 
		word sindex,	word dindex, 
		word sstride,	word dstride,
		word length,	word width,
		word op);
#define BYTBLT_ALL	0
#define BYTBLT_NONZERO	1
#define BYTBLT_ZERO	2
#endif

extern Stream *fdstream(int);		/* POSIX fd -> Helios stream convert */
extern int fileno(FILE *);		/* Clib stream -> POSIX fd convert   */
extern FILE *fdopen(int, string);	/* POSIX fd -> Clib FILE * 	     */

/* This macro is for compatability */
#define Heliosno(s) fdstream(fileno(s))
#endif
