#include <helios.h>
#include <stdio.h>
#include <posix.h>
#include <nonansi.h>
#include <memory.h>
#include <task.h>

extern void eval(int position, int number_workers,
                   int intervals, double *result);

int main(void)
{ int 		position, number_workers, temp, intervals;
  double	sum, total;
  Carrier	*fast_stack;
    
 		/* get the worker's position in the pipeline */
  read( 0, (BYTE *) &position, sizeof(int));
  temp = position + 1;
  write(1, (BYTE *) &temp, sizeof(int));

		/* get the length of the pipeline */
  read( 0, (BYTE *) &number_workers, sizeof(int));
  write(1, (BYTE *) &number_workers, sizeof(int));
   
		/* get the number of intervals per worker */
  read( 0, (BYTE *) &intervals, sizeof(int));
  write(1, (BYTE *) &intervals, sizeof(int));

  AccelerateCode(&eval);
  fast_stack = AllocFast(500, &MyTask->MemPool);
  if (fast_stack == Null(Carrier))
    eval(position, number_workers, intervals, &sum);
  else
   Accelerate(fast_stack, &eval, 3 * sizeof(int) + sizeof(double *),
   	      position, number_workers, intervals, &sum);
   	      
  read( 0, (BYTE *) &total, sizeof(double));
  total = total + sum;
  write(1, (BYTE *) &total, sizeof(double));
  
  return(0);
}

