/*
 * $Header: ClockP.h,v 1.11 88/02/25 16:24:45 swick Exp $
 */


/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/


#ifndef _XtClockP_h
#define _XtClockP_h

#include <X11/Clock.h>
#include <X11/CoreP.h>

#ifndef __time_h
#include <time.h>
#endif

#ifndef SEG_BUFF_SIZE
#define SEG_BUFF_SIZE		128
#endif

/* New fields for the clock widget instance record */
typedef struct
{
	 Pixel			fgpixel;	/* color index for text */
	 Pixel			Hipixel;	/* color index for Highlighting */
	 Pixel			Hdpixel;	/* color index for hands */
	 XFontStruct *		font;		/* font for text */
	 GC			myGC;		/* pointer to GraphicsContext */
	 GC			EraseGC;	/* eraser GC */
	 GC			HandGC;		/* Hand GC */
	 GC			HighGC;		/* Highlighting GC */
/* start of graph stuff */
	 int			update;		/* update frequence */
	 Dimension 		radius;		/* radius factor */
	 Boolean 		reverse_video;
	 Boolean 		chime;
	 Boolean 		beeped;
	 Boolean 		analog;
	 Boolean 		show_second_hand;
	 Dimension 		second_hand_length;
	 Dimension 		minute_hand_length;
	 Dimension 		hour_hand_length;
	 Dimension 		hand_width;
	 Dimension 		second_hand_width;
	 Position 		centerX;
	 Position 		centerY;
	 int			numseg;
	 int			padding;
	 XPoint			segbuff[ SEG_BUFF_SIZE ];
	 XPoint	*		segbuffptr;
	 XPoint	*		hour, *sec;
	 struct tm  		otm ;
	 XtIntervalId 		interval_id;
} ClockPart;

/* Full instance record declaration */
typedef struct _ClockRec
{
   	CorePart 		core;
   	ClockPart		clock;
} ClockRec;

#define OFFSET_OF_FGPIXEL	(sizeof(CorePart))
#define OFFSET_OF_HIPIXEL	(OFFSET_OF_FGPIXEL + sizeof(Pixel))
#define OFFSET_OF_HDPIXEL	(OFFSET_OF_HIPIXEL + sizeof(Pixel))
#define OFFSET_OF_FONT		(OFFSET_OF_HDPIXEL + sizeof(Pixel))
#define OFFSET_OF_UPDATE	(OFFSET_OF_FONT    + sizeof(XFontStruct *) + sizeof(GC) * 4)
#define OFFSET_OF_REVERSE_VID	(OFFSET_OF_UPDATE  + sizeof(int) + sizeof(Dimension))
#define OFFSET_OF_CHIME		(OFFSET_OF_REVERSE_VID + sizeof(Boolean))
#define OFFSET_OF_ANALOG	(OFFSET_OF_CHIME   + sizeof(Boolean) * 2)
#define OFFSET_OF_PADDING	(((OFFSET_OF_ANALOG  + sizeof(Boolean) * 2 + 3) & ~3) + sizeof(Dimension) * 5 + sizeof(Position) * 2 + sizeof(int))

/* New fields for the Clock widget class record */
typedef struct
{
	int			dummy;
} ClockClassPart;

/* Full class record declaration. */
typedef struct _ClockClassRec
{
   	CoreClassPart 		core_class;
   	ClockClassPart 		clock_class;
} ClockClassRec;

/* Class pointer. */
extern ClockClassRec 		clockClassRec;

#endif /* _XtClockP_h */
