/*
 * $Header: IntrinsicP.h,v 1.28 88/02/26 12:42:18 swick Exp $
 */

/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/*
 * Copyright (c) 1988, 1989 by Perihelion Software Ltd.
 * 
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting
 * documentation, and that the name of Perihelion Software Ltd.
 * not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written
 * prior permission.  Perihelion Software Ltd. makes no
 * representations about the suitability of this software
 * for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * Perihelion  Software  Ltd  disclaims all  warranties with
 * regard to this software, including all implied warranties
 * of merchantability  and fitness for a particular purpose.
 * In no event shall Perihelion Software Ltd be  liable  for 
 * any  special,  indirect or  consequential damages  or any
 * damages  whatsoever resulting from loss of use,  data  or
 * profits,  whether in an action of contract, negligence or
 * other  tortious action,  arising out of  or in connection 
 * with the use or performance of this software.
 */

#ifndef _XtintrinsicP_h
#define _XtintrinsicP_h

#ifndef _XtComposite_h
#define _XtComposite_h	/* to prevent Intrinsic.h from including it */
#define XTCOMPOSITE_DEFINED
#endif

#ifndef _XtIntrinsic_h
#include <X11/Intrinsic.h>
#endif

#include <X11/Xutil.h>

typedef unsigned long XtVersionType;

#define XT_VERSION 2
#define XT_REVISION 2
#define XtVersion (XT_VERSION * 1000 + XT_REVISION)

extern void 			_XtInherit( void );
extern void 			_XtInheritRealize( void );
extern void 			_XtInheritResize( void );
extern void 			_XtInheritExpose( void );
extern void 			_XtInheritSetValuesAlmost( void );
extern void 			_XtInheritAcceptFocus( void );
extern void 			_XtInheritQueryGeometry( void );
extern void 			_XtInheritGeometryManager( void );
extern void 			_XtInheritChangeManaged( void );
extern void 			_XtInheritInsertChild( void );
extern void 			_XtInheritDeleteChild( void );
extern void 			_XtInheritMoveFocusToNext( void );
extern void 			_XtInheritMoveFocusToPrev( void );

typedef void (*			XtProc)( void );

typedef void (*			XtWidgetProc)( 	   	 Widget widget );

typedef void (*			XtWidgetClassProc)(      WidgetClass class );

typedef void (*			XtArgsProc)(             Widget widget, ArgList args, Cardinal * num_args );

typedef void (*			XtInitProc)(             Widget request_widget, Widget new_widget );

typedef Boolean (*		XtSetValuesFunc)(        Widget widget, Widget request, Widget new );		/* returns TRUE if redisplay needed */
	
typedef Boolean (*		XtArgsFunc)(             Widget widget, ArgList args, Cardinal * num_args );

typedef void (*			XtAlmostProc)(           Widget widget, Widget new_widget, XtWidgetGeometry * request, XtWidgetGeometry * reply );

typedef void (*			XtExposeProc)(           Widget widget, XEvent * event, Region );
	
typedef void (*			XtRealizeProc)(          Widget widget, XtValueMask * mask, XSetWindowAttributes * attributes );

typedef void (*			XtCreatePopupChildProc)( Widget widget );

typedef XtGeometryResult (*	XtGeometryHandler)(      Widget widget, XtWidgetGeometry * request, XtWidgetGeometry * reply );

#ifndef XtCoreP_h
#include <X11/CoreP.h>
#endif

#ifdef XTCOMPOSITE_DEFINED
#undef XTCOMPOSITE_DEFINED
#undef _XtComposite_h
#include <X11/CompostP.h>
#endif

#define XtDisplay(     widget )	((widget)->core.screen->display)
#define XtScreen(      widget )	((widget)->core.screen)
#define XtWindow(      widget )	((widget)->core.window)
#define XtClass(       widget )	((widget)->core.widget_class)
#define XtParent(      widget )	((widget)->core.parent)
#define XtSuperclass(  widget )	(XtClass(widget)->core_class.superclass)
#define XtIsManaged(   widget ) ((widget)->core.managed)
#define XtIsRealized(  widget )	((widget)->core.window != NULL)
#define XtIsSensitive( widget )	((widget)->core.sensitive && (widget)->core.ancestor_sensitive)

extern void 	XtCreateWindow( Widget widget, unsigned int windowClass, Visual * visual, Mask valueMask, XSetWindowAttributes * attributes );

extern void 	XtResizeWidget( Widget widget, Dimension width, Dimension height, Dimension borderWidth );

extern void 	XtConfigureWidget( Widget widget, Position x, Position y, Dimension height, Dimension width, Dimension borderWidth );

extern void 	XtMoveWidget( Widget widget, Position x, Position y );

#endif /* _XtIntrinsicP_h */

/* DON'T ADD STUFF AFTER THIS #endif */
