/*
 * $Header: LabelP.h,v 1.15 88/02/26 09:27:32 swick Exp $
 */


/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/* 
 * LabelP.h - Private definitions for Label widget
 * 
 */

#ifndef _XtLabelP_h
#define _XtLabelP_h

/***********************************************************************
 *
 * Label Widget Private Data
 *
 ***********************************************************************/

#ifndef _XtLabel_h
#include <X11/Label.h>
#endif

#ifndef _SimpleP_h
#include <X11/SimpleP.h>
#endif

#define XtRjustify		"Justify"

/* New fields for the Label widget class record */

typedef struct
{
	int 		foo;
} LabelClassPart;

/* Full class record declaration */
typedef struct _LabelClassRec
{
    CoreClassPart	core_class;
    SimpleClassPart	simple_class;
    LabelClassPart	label_class;
} LabelClassRec;

extern LabelClassRec labelClassRec;

/* New fields for the Label widget record */
typedef struct
{
    /* resources */
    Pixel		foreground;
    XFontStruct	*	font;
    char	*	label;
    XtJustify		justify;
    Dimension		internal_width;
    Dimension		internal_height;

    /* private state */
    GC			normal_GC;
    GC          	gray_GC;
    Position		label_x;
    Position		label_y;
    Dimension		label_width;
    Dimension		label_height;
    unsigned int 	label_len;
} LabelPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _LabelRec
{
    CorePart		core;
    SimplePart		simple;
    LabelPart		label;
} LabelRec;

#define OFFSET_OF_LABEL_WIDGET_LABEL_FOREGROUND		(sizeof(CorePart) + sizeof(SimplePart))
#define OFFSET_OF_LABEL_WIDGET_LABEL_FONT		(OFFSET_OF_LABEL_WIDGET_LABEL_FOREGROUND + sizeof(Pixel))
#define OFFSET_OF_LABEL_WIDGET_LABEL_LABEL		(OFFSET_OF_LABEL_WIDGET_LABEL_FONT + sizeof(XFontStruct *))
#define OFFSET_OF_LABEL_WIDGET_LABEL_JUSTIFY		(OFFSET_OF_LABEL_WIDGET_LABEL_LABEL + sizeof(char *))
#define OFFSET_OF_LABEL_WIDGET_LABEL_INTERNAL_WIDTH	(OFFSET_OF_LABEL_WIDGET_LABEL_JUSTIFY + sizeof(XtJustify))
#define OFFSET_OF_LABEL_WIDGET_LABEL_INTERNAL_HEIGHT	(((OFFSET_OF_LABEL_WIDGET_LABEL_INTERNAL_WIDTH + 3) & ~3) + sizeof(Dimension))


#endif /* _XtLabelP_h */
