/*
 * $Header: Scroll.h,v 1.10 88/02/26 09:34:19 swick Exp $
 */


/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _Scroll_h
#define _Scroll_h

/****************************************************************
 *
 * Scrollbar Widget
 *
 ****************************************************************/


/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		pixel		White
 border		     BorderColor	pixel		Black
 borderWidth	     BorderWidth	int		1
 destroyCallback     Callback		Pointer		NULL
 foreground	     Color		pixel		Black
 height		     Height		int		length or thickness
 length		     Length		int		1
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 orientation	     Orientation	XtOrientation	XtorientVertical
 scrollDCursor	     ScrollDCursor	Cursor		XC_sb_down_arrow
 scrollHCursor	     ScrollHCursor	Cursor		XC_sb_h_double_arrow
 scrollLCursor	     ScrollLCursor	Cursor		XC_sb_left_arrow
 scrollProc	     Callback		Pointer		NULL
 scrollRCursor	     ScrollRCursor	Cursor		XC_sb_right_arrow
 scrollUCursor	     ScrollUCursor	Cursor		XC_sb_up_arrow
 scrollVCursor	     ScrollVCursor	Cursor		XC_sb_v_double_arrow
 sensitive	     Sensitive		Boolean		True
 shown		     Shown		float		0.0
 thickness	     Thickness		int		14
 thumb		     Thumb		Pixmap		Grey
 thumbProc	     Callback		Pointer		NULL
 top		     Top		float		0.0
 width		     Width		int		thickness or length
 x		     Position		int		0
 y		     Position		int		0

*/

#ifndef XtNlength
#define XtNlength		"length"
#endif

#ifndef XtNorientation
#define XtNorientation		"orientation"
#endif

#ifndef XtNscrollProc
#define XtNscrollProc		"scrollProc"
#endif

#ifndef XtNscrollDCursor
#define XtNscrollDCursor	"scrollDownCursor"
#endif

#ifndef XtNscrollHCursor
#define XtNscrollHCursor	"scrollHorizontalCursor"
#endif

#ifndef XtNscrollLCursor
#define XtNscrollLCursor	"scrollLeftCursor"
#endif

#ifndef XtNscrollRCursor
#define XtNscrollRCursor	"scrollRightCursor"
#endif

#ifndef XtNscrollUCursor
#define XtNscrollUCursor	"scrollUpCursor"
#endif

#ifndef XtNscrollVCursor
#define XtNscrollVCursor	"scrollVerticalCursor"
#endif

#ifndef XtNshown
#define XtNshown		"shown"
#endif

#ifndef XtNthickness
#define XtNthickness		"thickness"
#endif

#ifndef XtNthumb
#define XtNthumb		"thumb"
#endif

#ifndef XtNthumbProc
#define XtNthumbProc		"thumbProc"
#endif

#ifndef XtNtop
#define XtNtop			"top"
#endif

#ifndef XtCShown
#define XtCShown		"Shown"
#endif

#ifndef XtCTop
#define XtCTop			"Top"
#endif

#ifndef _XtOrientation_e
#define _XtOrientation_e

typedef enum
{
	XtorientHorizontal,
	XtorientVertical
} 					XtOrientation;
#endif /* _XtOrientation_e */

typedef struct _ScrollbarRec *		ScrollbarWidget;
typedef struct _ScrollbarClassRec *	ScrollbarWidgetClass;

extern WidgetClass 			scrollbarWidgetClass;

extern void XtScrollBarSetThumb( Widget, float, float ); /* scrollBar, top, shown */
/* Widget scrollBar; */
/* float top, shown; */

#ifndef _ScrollP_h
#include <X11/ScrollP.h>
#endif

#endif /* _Scroll_h */
