/*
 * $Header: Shell.h,v 1.12 88/02/26 12:46:56 swick Exp $
 */

/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _XtShell_h
#define _XtShell_h

/***********************************************************************
 *
 * Shell Widget
 *
 ***********************************************************************/
/*
 * Shell specific atoms
 */

#ifndef XtNiconName
#define XtNiconName		"iconName"
#endif

#ifndef XtCIconName
#define XtCIconName		"IconName"
#endif

#ifndef XtNiconPixmap
#define XtNiconPixmap		"iconPixmap"
#endif

#ifndef XtXIconPixmap
#define XtCIconPixmap		"IconPixmap"
#endif

#ifndef XtNiconWindow
#define XtNiconWindow		"iconWindow"
#endif

#ifndef XtCIconWindow
#define XtCIconWindow		"IconWindow"
#endif

#ifndef XtNiconMask
#define XtNiconMask		"iconMask"
#endif

#ifndef XtCIconMask
#define XtCIconMask		"IconMask"
#endif

#ifndef XtNwindowGroup
#define XtNwindowGroup		"windowGroup"
#endif

#ifndef XtCWindowGroup
#define XtCWindowGroup		"WindowGroup"
#endif
 
#ifndef XtNsaveUnder
#define XtNsaveUnder		"saveUnder"
#endif

#ifndef XtCSaveUnder
#define XtCSaveUnder		"SaveUnder"
#endif

#ifndef XtNtransient
#define XtNtransient		"transient"
#endif

#ifndef XtCTransient
#define XtCTransient		"Transient"
#endif

#ifndef XtNoverrideRedirect
#define XtNoverrideRedirect	"overrideRedirect"
#endif

#ifndef XtCOverrideRedirect
#define XtCOverrideRedirect	"OverrideRedirect"
#endif

#ifndef XtNallowShellResize
#define XtNallowShellResize	"allowShellResize"
#endif

#ifndef XtCAllowShellResize
#define XtCAllowShellResize	"AllowShellResize"
#endif

#ifndef XtNcreatePopupChildProc
#define XtNcreatePopupChildProc	"createPopupChildProc"
#endif

#ifndef XtCcreatePopupChildProc
#define XtCCreatePopupChildProc	"CreatePopupChildProc"
#endif

#ifndef XtNtitle
#define XtNtitle		"title"
#endif

#ifndef XtCTitle
#define XtCTitle		"Title"
#endif

/* 
 * The following are only used at creation and can not be changed via 
 * SetValues.
 */

#ifndef XtNiconX
#define XtNiconX		"iconX"
#endif

#ifndef XtCIconX
#define XtCIconX		"iconX"
#endif

#ifndef XtNiconY
#define XtNiconY		"iconY"
#endif

#ifndef XtCIconY
#define XtCIconY		"iconY"
#endif

#ifndef XtNinput
#define XtNinput		"input"
#endif

#ifndef XtCInput
#define XtCInput		"Input"
#endif

#ifndef XtNiconic
#define XtNiconic		"iconic"
#endif

#ifndef XtCIconic
#define XtCIconic		"Iconic"
#endif

#ifndef XtNinitialState
#define XtNinitialState		"initialstate"
#endif

#ifndef XtCInitialState
#define XtCInitialState		"InitialState"
#endif

#ifndef XtNgeometry
#define XtNgeometry		"geometry"
#endif

#ifndef XtCGeometry
#define XtCGeometry		"Geometry"
#endif

#ifndef XtNminWidth
#define XtNminWidth		"minWidth"
#endif

#ifndef XtCMinWidth
#define XtCMinWidth		"MinWidth"
#endif

#ifndef XtNminHeight
#define XtNminHeight		"minHeight"
#endif

#ifndef XtCMinHeight
#define XtCMinHeight		"MinHeight"
#endif

#ifndef XtNmaxWidth
#define XtNmaxWidth		"maxWidth"
#endif

#ifndef XtCMaxWidth
#define XtCMaxWidth		"MaxWidth"
#endif

#ifndef XtNmaxHeight
#define XtNmaxHeight		"maxHeight"
#endif

#ifndef XtCMaxHeight
#define XtCMaxHeight		"MaxHeight"
#endif

#ifndef XtNwidthInc
#define XtNwidthInc		"widthInc"
#endif

#ifndef XtCWidthInc
#define XtCWidthInc		"WidthInc"
#endif

#ifndef XtNheightInc
#define XtNheightInc		"heightInc"
#endif

#ifndef XtCHeightInc
#define XtCHeightInc		"HeightInc"
#endif

#ifndef XtNminAspectY
#define XtNminAspectY		"minAspectY"
#endif

#ifndef XtCMinAspectY
#define XtCMinAspectY		"MinAspectY"
#endif

#ifndef XtNmaxAspectY
#define XtNmaxAspectY		"maxAspectY"
#endif

#ifndef XtCMaxAspectY
#define XtCMaxAspectY		"MaxAspectY"
#endif

#ifndef XtNminAspectX
#define XtNminAspectX		"minAspectX"
#endif

#ifndef XtCMinAspectX
#define XtCMinAspectX		"MinAspectX"
#endif

#ifndef XtNmaxAspectX
#define XtNmaxAspectX		"maxAspectX"
#endif

#ifndef XtCMaxAspectX
#define XtCMaxAspectX		"MaxAspectX"
#endif

#ifndef XtNwmTimeout
#define XtNwmTimeout		"wmTimeout"
#endif

#ifndef XtCWmTimeout
#define XtCWmTimeout		"WmTimeout"
#endif

#ifndef XtNwaitForWm
#define XtNwaitForWm		"waitForWm"
#endif

#ifndef XtCWaitForWm
#define XtCWaitForWm		"WaitForWm"
#endif

/* Class record constants */

typedef struct _ShellClassRec *			ShellWidgetClass;
typedef struct _OverrideShellClassRec *		OverrideShellWidgetClass;
typedef struct _WMShellClassRec *		WMShellWidgetClass;
typedef struct _TransientShellClassRec *	TransientShellWidgetClass;
typedef struct _TopLevelShellClassRec *		TopLevelShellWidgetClass;
typedef struct _ApplicationShellClassRec *	ApplicationShellWidgetClass;

#ifndef SHELL
globalref WidgetClass 				shellWidgetClass;
globalref WidgetClass 				overrideShellWidgetClass;
globalref WidgetClass 				wmShellWidgetClass;
globalref WidgetClass 				transientShellWidgetClass;
globalref WidgetClass 				topLevelShellWidgetClass;
globalref WidgetClass 				applicationShellWidgetClass;
#endif

#ifndef _XtShellPrivate_h
#include <X11/ShellP.h>
#endif

#endif /* _XtShell_h */

/* DON'T ADD STUFF AFTER THIS #endif */
