/*
 * $Header: Text.h,v 1.10 88/02/26 10:09:06 swick Exp $
 */


/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _XtText_h
#define _XtText_h

/****************************************************************
 *
 * Text widget
 *
 ****************************************************************/

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		pixel		White
 border		     BorderColor	pixel		Black
 borderWidth	     BorderWidth	int		1
 destroyCallback     Callback		Pointer		NULL
 dialogHOffset	     Margin		int		10
 dialogVOffset	     Margin		int		10
 displayPosition     TextPosition	int		0
 editType	     EditType		XtTextEditType	XttextRead
 height		     Height		int		font height
 insertPosition	     TextPosition	int		0
 leftMargin	     Margin		int		2
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 selectTypes	     SelectTypes	Pointer		(internal)
 selection	     Selection		Pointer		empty selection
 sensitive	     Sensitive		Boolean		True
 textOptions	     TextOptions	int		0
 textSink	     TextSink		Pointer		(none)
 textSource	     TextSource		Pointer		(none)
 width		     Width		int		100
 x		     Position		int		0
 y		     Position		int		0

*/


#ifndef XtNtextOptions
#define XtNtextOptions		"textOptions"
#endif

#ifndef XtNdialogHOffset
#define XtNdialogHOffset	"dialogHOffset"
#endif

#ifndef XtNdialogVOffset
#define XtNdialogVOffset	"dialogVOffset"
#endif

#ifndef XtNdisplayPosition
#define XtNdisplayPosition      "displayPosition"
#endif

#ifndef XtNinsertPosition
#define XtNinsertPosition	"insertPosition"
#endif

#ifndef XtNleftMargin
#define XtNleftMargin		"leftMargin"
#endif

#ifndef XtNselectTypes
#define XtNselectTypes		"selectTypes"
#endif

#ifndef XtNtextSource
#define XtNtextSource		"textSource"
#endif

#ifndef XtNtextSink
#define XtNtextSink		"textSink"
#endif

#ifndef XtNselection
#define XtNselection		"selection"
#endif

#ifndef XtNeditType
#define XtNeditType		"editType"
#endif

#ifndef XtNfile
#define XtNfile			"file"
#endif

#ifndef XtNstring
#define XtNstring		"string"
#endif

#ifndef XtNlength
#define XtNlength		"length"
#endif

#ifndef XtNfont
#define XtNfont			"font"
#endif

/* Class record constants */

extern WidgetClass 		textWidgetClass;
extern Atom 			FMT8BIT;

typedef struct _TextClassRec *	TextWidgetClass;
typedef struct _TextRec *	TextWidget;

/* other stuff */

typedef long 			XtTextPosition;
typedef struct _XtTextSource 	XtTextSourceRec, * XtTextSource;
typedef struct _XtTextSink 	XtTextSinkRec, * XtTextSink;

typedef enum
{
	XttextRead,
	XttextAppend,
	XttextEdit
} 				XtTextEditType;

typedef enum
{
	XtselectNull,
	XtselectPosition,
	XtselectChar,
	XtselectWord,
    	XtselectLine,
    	XtselectParagraph,
    	XtselectAll
} 				XtTextSelectType;

#define wordBreak		0x01
#define scrollVertical		0x02
#define scrollHorizontal	0x04
#define scrollOnOverflow	0x08
#define resizeWidth		0x10
#define resizeHeight		0x20
#define editable		0x40

extern void XtTextDisplay( Widget ); /* w */
    /* Widget w; */

extern void XtTextSetSelectionArray( Widget, XtTextSelectType * ); /* w, sarray */
    /* Widget        w;		*/
    /* XtTextSelectType *sarray;   */

extern void XtTextSetLastPos( Widget, XtTextPosition ); /* w, lastPos */
    /* Widget        w;		*/
    /* XtTextPosition lastPos;  */

extern void XtTextGetSelectionPos( Widget, XtTextPosition *, XtTextPosition *  ); /* dpy, w, left, right */
    /* Widget        w;		*/
    /* XtTextPosition *left, *right;    */

extern void XtTextSetSource( Widget, XtTextSource, XtTextPosition ); /* dpy, w, source, startPos */
    /* Widget         w;	    */
    /* XtTextSource   source;       */
    /* XtTextPosition startPos;     */

extern int XtTextReplace( Widget, XtTextPosition, XtTextPosition, struct _XtTextBlock * ); /* w, startPos, endPos, text */
    /* Widget        w;		*/
    /* XtTextPosition   startPos, endPos; */
    /* XtTextBlock      *text; */

extern XtTextPosition XtTextTopPosition( Widget ); /* w */
    /* Widget        w;		*/

extern void XtTextSetInsertionPoint( Widget, XtTextPosition ); /*  w, position */
    /* Widget        w;		*/
    /* XtTextPosition position; */

extern XtTextPosition XtTextGetInsertionPoint( Widget ); /* w */
    /* Widget        w;		*/

extern void XtTextUnsetSelection( Widget ); /* w */
    /* Widget        w;		*/

extern void XtTextChangeOptions( Widget, int ); /* w, options */
    /* Widget        w;		*/
    /* int    options; */

extern int XtTextGetOptions( Widget ); /* w */
    /* Widget        w;		*/

extern void XtTextSetSelection( Widget, XtTextPosition, XtTextPosition ); /* w, left, right */
    /* Widget        w;		*/
    /* XtTextPosition left, right; */

extern void XtTextInvalidate( Widget, XtTextPosition, XtTextPosition  ); /* w, from, to */
    /* Widget        w;		*/
    /* XtTextPosition from, to; */

extern XtTextSource XtTextGetSource( Widget ) ; /* w */
    /* Widget        w;		*/

/*
 * Stuff from AsciiSink
 */

extern XtTextSink XtAsciiSinkCreate( Widget, ArgList, Cardinal ); /* parent, args, num_args */
    /* Widget parent;		*/
    /* ArgList args;		*/
    /* Cardinal num_args;	*/

extern void XtAsciiSinkDestroy( XtTextSink ); /* sink */
    /* XtTextSink  sink */

/*
 * from DiskSrc
 */
extern XtTextSource XtDiskSourceCreate( Widget, ArgList, Cardinal ); /* parent, args, num_args */
    /* Widget	parent;		*/
    /* ArgList	args;		*/
    /* Cardinal	num_args;	*/

extern void XtDiskSourceDestroy( XtTextSource ); /* src */
    /* XtTextSource src;	*/

/*
 * from StringSrc
 */

extern XtTextSource XtStringSourceCreate( Widget, ArgList, Cardinal ); /* parent, args, num_args */
    /* Widget parent;		*/
    /* ArgList args;		*/
    /* Cardinal num_args;	*/

extern void XtStringSourceDestroy( XtTextSource ); /* src */
    /* XtTextSource src;	*/

#ifndef _XtTextP_h
#include <X11/TextP.h>
#endif

#endif /* _XtText_h */
/* DON'T ADD STUFF AFTER THIS #endif */
