/* $Header: Xlib.h,v 11.139 88/02/20 20:19:23 rws Exp $ */
/* 
 * Copyright 1985, 1986, 1987 by the Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice appear in all copies and that both that 
 * copyright notice and this permission notice appear in supporting 
 * documentation, and that the name of M.I.T. not be used in advertising
 * or publicity pertaining to distribution of the software without specific, 
 * written prior permission. M.I.T. makes no representations about the 
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * The X Window System is a Trademark of MIT.
 *
 */

/*
 * Header: copyright.h v1.0 15th December 1988
 *
 *
 * Copyright (c) 1988, 1989 by Perihelion Software Ltd.
 * 
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting
 * documentation, and that the name of Perihelion Software Ltd.
 * not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written
 * prior permission.  Perihelion Software Ltd. makes no
 * representations about the suitability of this software
 * for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * Perihelion  Software  Ltd  disclaims all  warranties with
 * regard to this software, including all implied warranties
 * of merchantability  and fitness for a particular purpose.
 * In no event shall Perihelion Software Ltd be  liable  for 
 * any  special,  indirect or  consequential damages  or any
 * damages  whatsoever resulting from loss of use,  data  or
 * profits,  whether in an action of contract, negligence or
 * other  tortious action,  arising out of  or in connection 
 * with the use or performance of this software.
 */

/*
 *	Xlib.h - Header definition and support file for the C subroutine
 *	interface library (Xlib) to the X Window System Protocol (V11).
 *	Structures and symbols starting with "_" are private to the library.
 */

#ifndef _XLIB_H_
#define _XLIB_H_

#ifndef _XTYPES_H
#include <xtypes.h>
#endif

#ifndef __syslib_h
#include <syslib.h>
#endif

#ifndef __sem_h
#include <sem.h>
#endif

#ifndef X_H
#include <X11/X.h>
#endif


#define Bool 			int
#define Status 			int
#define True 			1
#define False			0

#define QueuedAlready 		0
#define QueuedAfterReading 	1
#define QueuedAfterFlush 	2

#ifdef UNIX
#define ConnectionNumber( dpy ) 	((dpy)->fd)
#else
#define ConnectionStream( dpy ) 	((dpy)->stream)
#endif

#define RootWindow( dpy, scr ) 		(((dpy)->screens[(scr)]).root)
#define DefaultScreen( dpy ) 		((dpy)->default_screen)
#define DefaultRootWindow( dpy ) 	(((dpy)->screens[(dpy)->default_screen]).root)
#define DefaultVisual( dpy, scr ) 	(((dpy)->screens[(scr)]).root_visual)
#define DefaultGC( dpy, scr ) 		(((dpy)->screens[(scr)]).default_gc)
#define BlackPixel( dpy, scr ) 		(((dpy)->screens[(scr)]).black_pixel)
#define WhitePixel( dpy, scr ) 		(((dpy)->screens[(scr)]).white_pixel)
#define AllPlanes 			(~0)
#define QLength( dpy ) 			((dpy)->qlen)
#define DisplayWidth( dpy, scr ) 	(((dpy)->screens[(scr)]).width)
#define DisplayHeight( dpy, scr ) 	(((dpy)->screens[(scr)]).height)
#define DisplayWidthMM( dpy, scr )	(((dpy)->screens[(scr)]).mwidth)
#define DisplayHeightMM( dpy, scr )	(((dpy)->screens[(scr)]).mheight)
#define DisplayPlanes( dpy, scr ) 	(((dpy)->screens[(scr)]).root_depth)
#define DisplayCells( dpy, scr ) 	(DefaultVisual((dpy), (scr))->map_entries)
#define ScreenCount( dpy ) 		((dpy)->nscreens)
#define ServerVendor( dpy ) 		((dpy)->vendor)
#define ProtocolVersion( dpy ) 		((dpy)->proto_major_version)
#define ProtocolRevision( dpy ) 	((dpy)->proto_minor_version)
#define VendorRelease( dpy ) 		((dpy)->release)
#define DisplayString( dpy ) 		((dpy)->display_name)
#define DefaultDepth( dpy, scr ) 	(((dpy)->screens[(scr)]).root_depth)
#define DefaultColormap( dpy, scr )	(((dpy)->screens[(scr)]).cmap)
#define BitmapUnit( dpy ) 		((dpy)->bitmap_unit)
#define BitmapBitOrder( dpy ) 		((dpy)->bitmap_bit_order)
#define BitmapPad( dpy ) 		((dpy)->bitmap_pad)
#define ImageByteOrder( dpy ) 		((dpy)->byte_order)
#define NextRequest( dpy )		((dpy)->request + 1)
#define LastKnownRequestProcessed( dpy ) ((dpy)->last_request_read)

/* macros for screen oriented applications (toolkit) */
#define ScreenOfDisplay(dpy, scr)	(&((dpy)->screens[(scr)]))
#define DefaultScreenOfDisplay(dpy)	(&((dpy)->screens[(dpy)->default_screen]))
#define DisplayOfScreen(s)		((s)->display)
#define RootWindowOfScreen(s)		((s)->root)
#define BlackPixelOfScreen(s)		((s)->black_pixel)
#define WhitePixelOfScreen(s)		((s)->white_pixel)
#define DefaultColormapOfScreen(s)	((s)->cmap)
#define DefaultDepthOfScreen(s)		((s)->root_depth)
#define DefaultGCOfScreen(s)		((s)->default_gc)
#define DefaultVisualOfScreen(s)	((s)->root_visual)
#define WidthOfScreen(s)		((s)->width)
#define HeightOfScreen(s)		((s)->height)
#define WidthMMOfScreen(s)		((s)->mwidth)
#define HeightMMOfScreen(s)		((s)->mheight)
#define PlanesOfScreen(s)		((s)->root_depth)
#define CellsOfScreen(s)		(DefaultVisualOfScreen((s))->map_entries)
#define MinCmapsOfScreen(s)		((s)->min_maps)
#define MaxCmapsOfScreen(s)		((s)->max_maps)
#define DoesSaveUnders(s)		((s)->save_unders)
#define DoesBackingStore(s)		((s)->backing_store)
#define EventMaskOfScreen(s)		((s)->root_input_mask)

/*
 * Extensions need a way to hang private data on some structures.
 */
typedef struct _XExtData
{
	int		 	number;			/* number returned by XRegisterExtension */
	struct _XExtData *	next;			/* next item on list of data for structure */
	int (*			free_private)();	/* called to free private storage */
	char *		 	private_data;		/* data private to this extension. */
} XExtData;

/*
 * This file contains structures used by the extension mechanism.
 */
typedef struct
{		/* public to extension, cannot be changed */
	int 			extension;		/* extension number */
	int 			major_opcode;		/* major op-code assigned by server */
	int 			first_event;		/* first event number for the extension */
	int 			first_error;		/* first error number for the extension */
} XExtCodes;

/*
 * This structure is private to the library.
 */
typedef struct _XExten
{							/* private to extension mechanism */
	struct _XExten *	next;			/* next in list */
	XExtCodes 		codes;			/* public information, all extension told */
	int (*			create_GC)();		/* routine to call when GC created */
	int (*			copy_GC)();		/* routine to call when GC copied */
	int (*			flush_GC)();		/* routine to call when GC flushed */
	int (*			free_GC)();		/* routine to call when GC freed */
	int (*			create_Font)();		/* routine to call when Font created */
	int (*			free_Font)();		/* routine to call when Font freed */
	int (*			close_display)();	/* routine to call when connection closed */
	int (*			error)();		/* who to call when an error occurs */
	int (*			error_string)();  	/* routine to supply error string */
} _XExtension;

/*
 * Data structure for setting graphics context.
 */
typedef struct
{
	int			function;		/* logical operation */
	unsigned long		plane_mask;		/* plane mask */
	unsigned long		foreground;		/* foreground pixel */
	unsigned long		background;		/* background pixel */
	int			line_width;		/* line width */
	int 			line_style;		/* LineSolid, LineOnOffDash, LineDoubleDash */
	int 			cap_style;		/* CapNotLast, CapButt, CapRound, CapProjecting */
	int 			join_style;		/* JoinMiter, JoinRound, JoinBevel */
	int 			fill_style;		/* FillSolid, FillTiled, FillStippled, FillOpaeueStippled */
	int 			fill_rule;		/* EvenOddRule, WindingRule */
	int 			arc_mode;		/* ArcChord, ArcPieSlice */
	Pixmap 			tile;			/* tile pixmap for tiling operations */
	Pixmap 			stipple;		/* stipple 1 plane pixmap for stipping */
	int 			ts_x_origin;		/* offset for tile or stipple operations */
	int 			ts_y_origin;
        Font 			font;	        	/* default text font for text operations */
	int 			subwindow_mode; 	/* ClipByChildren, IncludeInferiors */
	Bool 			graphics_exposures; 	/* boolean, should exposures be generated */
	int 			clip_x_origin;		/* origin for clipping */
	int 			clip_y_origin;
	Pixmap 			clip_mask;		/* bitmap clipping; other calls for rects */
	int 			dash_offset;		/* patterned/dashed line information */
	char 			dashes;
} XGCValues;

/*
 * Graphics context.  All Xlib routines deal in this rather than
 * in raw protocol GContext ID's.  This is so that the library can keep
 * a "shadow" set of values, and thus avoid passing values over the
 * wire which are not in fact changing. 
 */

typedef struct _XGC
{
    	XExtData *		ext_data;		/* hook for extension to hang data */
    	GContext		gid;			/* protocol ID for graphics context */
    	Bool			rects;			/* boolean: TRUE if clipmask is list of rectangles */
    	Bool			dashes;			/* boolean: TRUE if dash-list is really a list */
    	unsigned long 		dirty;			/* cache dirty bits */
    	XGCValues		values;			/* shadow structure of values */
} *GC;


/*
 * Visual structure; contains information about colormapping possible.
 */
typedef struct
{
	XExtData *		ext_data;		/* hook for extension to hang data */
	VisualID 		visualid;		/* visual id of this visual */
	int	 		class;			/* class of screen (monochrome, etc.) */
	unsigned long 		red_mask;		/* mask values */
	unsigned long		green_mask;
	unsigned long		blue_mask;
	int	 		bits_per_rgb;		/* log base 2 of distinct color values */
	int	 		map_entries;		/* color map entries */
} Visual;

/*
 * Depth structure; contains information for each possible depth.
 */	
typedef struct
{
	int			depth;			/* this depth (Z) of the depth */
	int			nvisuals;		/* number of Visual types at this depth */
	Visual *		visuals;		/* list of visuals possible at this depth */
} Depth;

/*
 * Information about the screen.
 */
typedef struct
{
	XExtData *		ext_data;		/* hook for extension to hang data */
	struct _XDisplay *	display;		/* back pointer to display structure */
	Window			root;			/* Root window id. */
	int			width, height;		/* width and height of screen */
	int			mwidth, mheight;	/* width and height of  in millimeters */
	int			ndepths;		/* number of depths possible */
	Depth *			depths;			/* list of allowable depths on the screen */
	int			root_depth;		/* bits per pixel */
	Visual *		root_visual;		/* root visual */
	GC			default_gc;		/* GC for the root root visual */
	Colormap		cmap;			/* default color map */
	unsigned long		white_pixel;
	unsigned long		black_pixel;		/* White and Black pixel values */
	int			max_maps, min_maps;	/* max and min color maps */
	int			backing_store;		/* Never, WhenMapped, Always */
	Bool			save_unders;	
	long			root_input_mask;	/* initial root input mask */
} Screen;

/*
 * Format structure; describes ZFormat data the screen will understand.
 */

typedef struct
{
	XExtData *		ext_data;		/* hook for extension to hang data */
	int 			depth;			/* depth of this image format */
	int 			bits_per_pixel;		/* bits/pixel at this depth */
	int 			scanline_pad;		/* scanline must padded to this multiple */
} ScreenFormat;


/*
 * Data structure for setting window attributes.
 */

typedef struct
{
    	Pixmap			background_pixmap;	/* background or None or ParentRelative */
    	unsigned long		background_pixel;	/* background pixel */
    	Pixmap			border_pixmap;		/* border of the window */
    	unsigned long		border_pixel;		/* border pixel value */
    	int			bit_gravity;		/* one of bit gravity values */
    	int			win_gravity;		/* one of the window gravity values */
    	int			backing_store;		/* NotUseful, WhenMapped, Always */
    	unsigned long		backing_planes;		/* planes to be preseved if possible */
    	unsigned long		backing_pixel;		/* value to use in restoring planes */
    	Bool			save_under;		/* should bits under be saved? (popups) */
    	long			event_mask;		/* set of events that should be saved */
    	long			do_not_propagate_mask;	/* set of events that should not propagate */
    	Bool			override_redirect;	/* boolean value for override-redirect */
    	Colormap		colormap;		/* color map to be associated with window */
    	Cursor			cursor;			/* cursor to be displayed (or None) */
} XSetWindowAttributes;

typedef struct
{
    	int			x, y;			/* location of window */
    	int			width, height;		/* width and height of window */
    	int			border_width;		/* border width of window */
    	int			depth;          	/* depth of window */
    	Visual *		visual;			/* the associated visual structure */
    	Window			root;        		/* root of screen containing window */
    	int			class;			/* InputOutput, InputOnly*/
    	int			bit_gravity;		/* one of bit gravity values */
    	int			win_gravity;		/* one of the window gravity values */
    	int			backing_store;		/* NotUseful, WhenMapped, Always */
    	unsigned long		backing_planes;		/* planes to be preserved if possible */
    	unsigned long		backing_pixel;		/* value to be used when restoring planes */
    	Bool			save_under;		/* boolean, should bits under be saved? */
   	Colormap		colormap;		/* color map to be associated with window */
   	Bool			map_installed;		/* boolean, is color map currently installed*/
   	int			map_state;		/* IsUnmapped, IsUnviewable, IsViewable */
    	long			all_event_masks;	/* set of events all people have interest in*/
    	long			your_event_mask;	/* my event mask */
    	long			do_not_propagate_mask;	/* set of events that should not propagate */
    	Bool			override_redirect;	/* boolean value for override-redirect */
    	Screen *		screen;			/* back pointer to correct screen */
} XWindowAttributes;

/*
 * Data structure for host setting; getting routines.
 *
 */

typedef struct
{
	int 			family;		/* for example AF_DNET */
	int 			length;		/* length of address, in bytes */
	char *			address;		/* pointer to where to find the bytes */
} XHostAddress;

/*
 * Data structure for "image" data, used by image manipulation routines.
 */
typedef struct _XImage
{
    	int			width, height;		/* size of image */
    	int			xoffset;		/* number of pixels offset in X direction */
    	int			format;			/* XYBitmap, XYPixmap, ZPixmap */
    	char *			data;			/* pointer to image data */
    	int			byte_order;		/* data byte order, LSBFirst, MSBFirst */
    	int			bitmap_unit;		/* quant. of scanline 8, 16, 32 */
    	int			bitmap_bit_order;	/* LSBFirst, MSBFirst */
    	int			bitmap_pad;		/* 8, 16, 32 either XY or ZPixmap */
    	int			depth;			/* depth of image */
    	int			bytes_per_line;		/* accelarator to next line */
    	int			bits_per_pixel;		/* bits per pixel (ZPixmap) */
    	unsigned long		red_mask;		/* bits in z arrangment */
    	unsigned long		green_mask;
    	unsigned long		blue_mask;
    	char *			obdata;			/* hook for the object routines to hang on */
    	struct funcs
    	{				/* image manipulation routines */
		struct _XImage * (*     create_image  )();
		int (*                  destroy_image )( struct _XImage * );
		unsigned long (*        get_pixel     )( struct _XImage  *, int, int );
		int (*                  put_pixel     )( struct _XImage  *, int, int, unsigned long );
		struct _XImage * (*     sub_image     )( struct _XImage  *, int, int, unsigned int, unsigned int );
		int (*                  add_pixel     )( struct _XImage  *, unsigned long );
	} f;
} XImage;

/* 
 * Data structure for XReconfigureWindow
 */
typedef struct
{
    	int 			x, y;
    	int 			width, height;
    	int 			border_width;
    	Window 			sibling;
    	int 			stack_mode;
} XWindowChanges;

/*
 * Data structure used by color operations
 */
typedef struct
{
	unsigned long 		pixel;
	unsigned short		red, green, blue;
	char 			flags;  /* do_red, do_green, do_blue */
	char 			pad;
} XColor;

/* 
 * Data structures for graphics operations.  On most machines, these are
 * congruent with the wire protocol structures, so reformatting the data
 * can be avoided on these architectures.
 */
typedef struct
{
	short 			x1, y1, x2, y2;
} XSegment;

typedef struct
{
    	short 			x, y;
} XPoint;
    
typedef struct
{
    	short 			x, y;
    	unsigned short		width, height;
} XRectangle;
    
typedef struct
{
    	short 			x, y;
    	unsigned short 		width, height;
    	short 			angle1, angle2;
} XArc;


/* Data structure for XChangeKeyboardControl */

typedef struct
{
        int 			key_click_percent;
        int 			bell_percent;
        int 			bell_pitch;
        int 			bell_duration;
        int 			led;
        int 			led_mode;
        int 			key;
        int 			auto_repeat_mode;   /* On, Off, Default */
} XKeyboardControl;

/* Data structure for XGetKeyboardControl */

typedef struct
{
        int 			key_click_percent;
	int 			bell_percent;
	unsigned int		bell_pitch, bell_duration;
	unsigned long 		led_mask;
	int 			global_auto_repeat;
	char 			auto_repeats[ 32 ];
} XKeyboardState;

/* Data structure for XGetMotionEvents.  */

typedef struct
{
        Time 			time;
	unsigned short 		x, y;
} XTimeCoord;

/* Data structure for X{Set,Get}ModifierMapping */

typedef struct
{
 	int 			max_keypermod;		/* The server's max # of keys per modifier */
 	KeyCode *		modifiermap;		/* An 8 by max_keypermod array of modifiers */
} XModifierKeymap;


/*
 * Display datatype maintaining display specific data.
 */

typedef struct _XDisplay
{
	XExtData *	 	ext_data;		/* hook for extension to hang data */
	struct _XDisplay *	next; 			/* next open Display on list */
	Stream *		stream;			/* Network socket. */
	Semaphore	 	lock;			/* access lock for the display */
	int		 	lock;			/* is someone in critical section? */
	int	 	 	proto_major_version;	/* maj. version of server's X protocol */
	int		 	proto_minor_version;	/* minor version of servers X protocol */
	char *		 	vendor;			/* vendor of the server hardware */
        long		 	resource_base;		/* resource ID base */
	long		 	resource_mask;		/* resource ID mask bits */
	long		 	resource_id;		/* allocator current ID */
	int		 	resource_shift;		/* allocator shift to correct bits */
	XID (*			resource_alloc)();	/* allocator function */
	int		 	byte_order;		/* screen byte order, LSBFirst, MSBFirst */
	int		 	bitmap_unit;		/* padding and data requirements */
	int		 	bitmap_pad;		/* padding requirements on bitmaps */
	int		 	bitmap_bit_order;	/* LeastSignificant or MostSignificant */
	int		 	nformats;		/* number of pixmap formats in list */
	ScreenFormat *	 	pixmap_format;		/* pixmap format list */
	int		 	vnumber;		/* Xlib's X protocol version number. */
	int		 	release;		/* release of the server */
	struct _XSQEvent *	head, *tail;		/* Input event queue. */
	int		 	qlen;			/* Length of input event queue */
	unsigned long	 	last_request_read; 	/* seq number of last event read */
	unsigned long	 	request;		/* sequence number of last request. */
	char *		 	last_req;		/* beginning of last request, or dummy */
	char *		 	buffer;			/* Output buffer starting address. */
	char *		 	bufptr;			/* Output buffer index pointer. */
	char *		 	bufmax;			/* Output buffer maximum+1 address. */
	unsigned	 	max_request_size;	/* maximum number 32 bit words in request*/
	struct _XrmHashBucketRec *	db;
	int (*			synchandler)();	/* Synchronization handler */
	char *		 	display_name;		/* "host:display" string used on this connect*/
	int		 	default_screen;		/* default screen for operations */
	int		 	nscreens;		/* number of screens on this server*/
	Screen *		screens;		/* pointer to list of screens */
	int		 	motion_buffer;		/* size of motion buffer */
	Window		 	current;		/* for use internally for Keymap notify */
	int		 	min_keycode;		/* minimum defined keycode */
	int		 	max_keycode;		/* maximum defined keycode */
	KeySym *		keysyms;		/* This server's keysyms */
	XModifierKeymap	*	modifiermap;		/* This server's modifier keymap */
	int		 	keysyms_per_keycode;	/* number of rows */
	char *			xdefaults;		/* contents of defaults from server */
	char *			scratch_buffer;		/* place to hang scratch buffer */
	unsigned long	 	scratch_length;		/* length of scratch buffer */
	int		 	ext_number;		/* extension number on this display */
	_XExtension *	 	ext_procs;		/* extensions initialized on this display */
	/*
	 * the following can be fixed size, as the protocol defines how
	 * much address space is available. 
	 * While this could be done using the extension vector, there
	 * may be MANY events processed, so a search through the extension
	 * list to find the right procedure for each event might be
	 * expensive if many extensions are being used.
	 */
	Bool (*			event_vec[ 128 ])(); 	/* vector for wire to event */
	Status (*		wire_vec[  128 ])(); 	/* vector for event to wire */
} Display;

#ifndef _Xresource_h
#include <X11/Xresource.h>
#endif

typedef struct _XrmHashBucketRec
{
    	XrmHashBucket		next;       		/* Next entry in this hash chain	*/
    	XrmQuark		quark;      		/* Quark for string			*/
    	XrmRepresentation   	type;       		/* Representation of value (if any)     */
    	XrmValue		value;      		/* Value of this node (if any)	    	*/
    	XrmHashTable		tables[ 2 ];  		/* Hash table pointers for tight, loose */
} XrmHashBucketRec;

/*
 * A "XEvent" structure always  has type as the first entry.  This 
 * uniquely identifies what  kind of event it is.  The second entry
 * is always a pointer to the display the event was read from.
 * The third entry is always a window of one type or another,
 * carefully selected to be useful to toolkit dispatchers.  (Except
 * for keymap events, which have no window.) You
 * must not change the order of the three elements or toolkits will
 * break! The pointer to the generic event must be cast before use to 
 * access any other information in the structure.
 */

/*
 * Definitions of specific events.
 */

typedef struct
{
	int		type;		/* of event */
	unsigned long	serial;		/* # of last request processed by server */
	Bool		send_event;	/* true if this came from a SendEvent request */
	Display	*	display;	/* Display the event was read from */
	Window		window;	        /* "event" window it is reported relative to */
	Window		root;	        /* root window that the event occured on */
	Window		subwindow;	/* child window */
	Time		time;		/* milliseconds */
	int		x, y;		/* pointer x, y coordinates in event window */
	int		x_root, y_root;	/* coordinates relative to root */
	unsigned int	state;		/* key or button mask */
	unsigned int	keycode;	/* detail */
	Bool		same_screen;	/* same screen flag */
} XKeyEvent;
typedef XKeyEvent XKeyPressedEvent;
typedef XKeyEvent XKeyReleasedEvent;

typedef struct
{
	int 		type;		/* of event */
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;	        /* "event" window it is reported relative to */
	Window 		root;	        /* root window that the event occured on */
	Window 		subwindow;	/* child window */
	Time 		time;		/* milliseconds */
	int 		x, y;		/* pointer x, y coordinates in event window */
	int 		x_root, y_root;	/* coordinates relative to root */
	unsigned int 	state;		/* key or button mask */
	unsigned int 	button;		/* detail */
	Bool 		same_screen;	/* same screen flag */
} XButtonEvent;
typedef XButtonEvent XButtonPressedEvent;
typedef XButtonEvent XButtonReleasedEvent;

typedef struct
{
	int 		type;		/* of event */
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;	        /* "event" window reported relative to */
	Window 		root;	        /* root window that the event occured on */
	Window 		subwindow;	/* child window */
	Time 		time;		/* milliseconds */
	int 		x, y;		/* pointer x, y coordinates in event window */
	int 		x_root, y_root;	/* coordinates relative to root */
	unsigned int 	state;		/* key or button mask */
	char 		is_hint;	/* detail */
	Bool 		same_screen;	/* same screen flag */
} XMotionEvent;
typedef XMotionEvent XPointerMovedEvent;

typedef struct
{
	int 		type;		/* of event */
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;	        /* "event" window reported relative to */
	Window 		root;	        /* root window that the event occured on */
	Window 		subwindow;	/* child window */
	Time 		time;		/* milliseconds */
	int 		x, y;		/* pointer x, y coordinates in event window */
	int 		x_root, y_root;	/* coordinates relative to root */
	int 		mode;		/* NotifyNormal, NotifyGrab, NotifyUngrab */
	int 		detail;
	/*
	 * NotifyAncestor, NotifyVirtual, NotifyInferior, 
	 * NotifyNonLinear,NotifyNonLinearVirtual
	 */
	Bool 		same_screen;	/* same screen flag */
	Bool 		focus;		/* boolean focus */
	unsigned int 	state;		/* key or button mask */
} XCrossingEvent;
typedef XCrossingEvent XEnterWindowEvent;
typedef XCrossingEvent XLeaveWindowEvent;

typedef struct
{
	int 		type;		/* FocusIn or FocusOut */
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;		/* window of event */
	int 		mode;		/* NotifyNormal, NotifyGrab, NotifyUngrab */
	int 		detail;
	/*
	 * NotifyAncestor, NotifyVirtual, NotifyInferior, 
	 * NotifyNonLinear,NotifyNonLinearVirtual, NotifyPointer,
	 * NotifyPointerRoot, NotifyDetailNone 
	 */
} XFocusChangeEvent;
typedef XFocusChangeEvent XFocusInEvent;
typedef XFocusChangeEvent XFocusOutEvent;

/* generated on EnterWindow and FocusIn  when KeyMapState selected */
typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;
	char 		key_vector[ 32 ];
} XKeymapEvent;	

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;
	int 		x, y;
	int 		width, height;
	int 		count;		/* if non-zero, at least this many more */
} XExposeEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Drawable	drawable;
	int 		x, y;
	int 		width, height;
	int 		count;		/* if non-zero, at least this many more */
	int 		major_code;	/* core is CopyArea or CopyPlane */
	int 		minor_code;	/* not defined in the core */
} XGraphicsExposeEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Drawable	drawable;
	int 		major_code;	/* core is CopyArea or CopyPlane */
	int 		minor_code;	/* not defined in the core */
} XNoExposeEvent;

typedef struct
{
	int 		type;
	unsigned long	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;
	int 		state;		/* either Obscured or UnObscured */
} XVisibilityEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		parent;		/* parent of the window */
	Window 		window;		/* window id of window created */
	int 		x, y;		/* window location */
	int 		width, height;	/* size of window */
	int 		border_width;	/* border width */
	Bool 		override_redirect;	/* creation should be overridden */
} XCreateWindowEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		event;
	Window 		window;
} XDestroyWindowEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		event;
	Window 		window;
	Bool 		from_configure;
} XUnmapEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		event;
	Window 		window;
	Bool 		override_redirect;	/* boolean, is override set... */
} XMapEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		parent;
	Window 		window;
} XMapRequestEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window		event;
	Window 		window;
	Window 		parent;
	int 		x, y;
	Bool 		override_redirect;
} XReparentEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		event;
	Window 		window;
	int 		x, y;
	int 		width, height;
	int 		border_width;
	Window 		above;
	Bool 		override_redirect;
} XConfigureEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		event;
	Window 		window;
	int 		x, y;
} XGravityEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display 	*display;	/* Display the event was read from */
	Window 		window;
	int 		width, height;
} XResizeRequestEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		parent;
	Window 		window;
	int 		x, y;
	int 		width, height;
	int 		border_width;
	Window 		above;
	int 		detail;		/* Above, Below, TopIf, BottomIf, Opposite */
	unsigned long 	value_mask;
} XConfigureRequestEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		event;
	Window 		window;
	int 		place;		/* PlaceOnTop, PlaceOnBottom */
} XCirculateEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		parent;
	Window 		window;
	int 		place;		/* PlaceOnTop, PlaceOnBottom */
} XCirculateRequestEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;
	Atom 		atom;
	Time 		time;
	int 		state;		/* NewValue, Deleted */
} XPropertyEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;
	Atom 		selection;
	Time 		time;
} XSelectionClearEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		owner;		/* must be next after type */
	Window 		requestor;
	Atom 		selection;
	Atom 		target;
	Atom 		property;
	Time 		time;
} XSelectionRequestEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		requestor;	/* must be next after type */
	Atom 		selection;
	Atom 		target;
	Atom 		property;		/* ATOM or None */
	Time 		time;
} XSelectionEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;
	Colormap 	colormap;	/* COLORMAP or None */
	Bool 		new;
	int 		state;		/* ColormapInstalled, ColormapUninstalled */
} XColormapEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;
	Atom 		message_type;
	int 		format;
	union
	{
		char 	b[ 20 ];
		short 	s[ 10 ];
		int 	l[ 5  ];
		} data;
} XClientMessageEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;		/* unused */
	int 		request;	/* one of MappingModifier, MappingKeyboard, MappingPointer */
	int 		first_keycode;	/* first keycode */
	int 		count;		/* defines range of change w. first_keycode*/
} XMappingEvent;

typedef struct
{
	int 		type;
	Display *	display;	/* Display the event was read from */
	XID 		resourceid;	/* resource id */
	unsigned long 	serial;		/* serial number of failed request */
	char 		error_code;	/* error code of failed request */
	char 		request_code;	/* Major op-code of failed request */
	char 		minor_code;	/* Minor op-code of failed request */
} XErrorEvent;

typedef struct
{
	int 		type;
	unsigned long 	serial;		/* # of last request processed by server */
	Bool 		send_event;	/* true if this came from a SendEvent request */
	Display *	display;	/* Display the event was read from */
	Window 		window;		/* window on which event was requested in event mask */
} XAnyEvent;

/*
 * this union is defined so Xlib can always use the same sized
 * event structure internally, to avoid memory fragmentation.
 */

typedef union _XEvent
{
        int 			type;		/* must not be changed; first element */
	XAnyEvent 		xany;
	XKeyEvent 		xkey;
	XButtonEvent 		xbutton;
	XMotionEvent 		xmotion;
	XCrossingEvent 		xcrossing;
	XFocusChangeEvent 	xfocus;
	XExposeEvent 		xexpose;
	XGraphicsExposeEvent 	xgraphicsexpose;
	XNoExposeEvent 		xnoexpose;
	XVisibilityEvent 	xvisibility;
	XCreateWindowEvent 	xcreatewindow;
	XDestroyWindowEvent 	xdestroywindow;
	XUnmapEvent 		xunmap;
	XMapEvent 		xmap;
	XMapRequestEvent 	xmaprequest;
	XReparentEvent 		xreparent;
	XConfigureEvent 	xconfigure;
	XGravityEvent 		xgravity;
	XResizeRequestEvent 	xresizerequest;
	XConfigureRequestEvent 	xconfigurerequest;
	XCirculateEvent 	xcirculate;
	XCirculateRequestEvent 	xcirculaterequest;
	XPropertyEvent 		xproperty;
	XSelectionClearEvent 	xselectionclear;
	XSelectionRequestEvent 	xselectionrequest;
	XSelectionEvent 	xselection;
	XColormapEvent 		xcolormap;
	XClientMessageEvent 	xclient;
	XMappingEvent 		xmapping;
	XErrorEvent 		xerror;
	XKeymapEvent 		xkeymap;
	long 			pad[ 24 ];
} XEvent;

/*
 * _QEvent datatype for use in input queueing.
 */

typedef struct _XSQEvent
{
    struct _XSQEvent * 		next;
    XEvent 			event;
} _XQEvent;


#define XAllocID(dpy) 		((*(dpy)->resource_alloc)(( dpy )))

/*
 * per character font metric information.
 */

typedef struct
{
    short		lbearing;		/* origin to left edge of raster */
    short		rbearing;		/* origin to right edge of raster */
    short		width;			/* advance to next char's origin */
    short		ascent;			/* baseline to top edge of raster */
    short		descent;		/* baseline to bottom edge of raster */
    unsigned short 	attributes;		/* per char flags (not predefined) */
} XCharStruct;


/*
 * To allow arbitrary information with fonts, there are additional properties
 * returned.
 */

typedef struct
{
    Atom 		name;
    unsigned long 	card32;
} XFontProp;

typedef struct
{
    XExtData *		ext_data;		/* hook for extension to hang data */
    Font        	fid;            	/* Font id for this font */
    unsigned		direction;		/* hint about direction the font is painted */
    unsigned		min_char_or_byte2;	/* first character */
    unsigned		max_char_or_byte2;	/* last character */
    unsigned		min_byte1;		/* first row that exists */
    unsigned		max_byte1;		/* last row that exists */
    Bool		all_chars_exist;	/* flag if all characters have non-zero size*/
    unsigned		default_char;		/* char to print for undefined character */
    int         	n_properties;   	/* how many properties there are */
    XFontProp *		properties;		/* pointer to array of additional properties*/
    XCharStruct		min_bounds;		/* minimum bounds over all existing char*/
    XCharStruct		max_bounds;		/* minimum bounds over all existing char*/
    XCharStruct	*	per_char;		/* first_char to last_char information */
    int			ascent;			/* log. extent above baseline for spacing */
    int			descent;		/* log. descent below baseline for spacing */
} XFontStruct;

/*
 * PolyText routines take these as arguments.
 */
typedef struct
{
    char *		chars;			/* pointer to string */
    int 		nchars;			/* number of characters */
    int	 		delta;			/* delta between strings */
    Font 		font;			/* font to print it in, None don't change */
} XTextItem;

typedef struct
{		/* normal 16 bit characters are two bytes */
    unsigned char 	byte1;
    unsigned char 	byte2;
} XChar2b;

typedef struct
{
    XChar2b *		chars;			/* two byte characters */
    int 		nchars;			/* number of characters */
    int 		delta;			/* delta between strings */
    Font 		font;			/* font to print it in, None don't change */
} XTextItem16;


/* 
 * X function declarations.
 */

/*
 * missing function declarations added by NC
 */


#ifndef _XUTIL_H_
#include <X11/Xutil.h>		/* for XSizeHints and XWMHints */
#endif


void		bcopy(				char *,    char *, int );
void		bzero(				char *,	   int );
int		ffs(				int        );

void		XActivateScreenSaver(		Display *  );
void		XAddHost(			Display *, XHostAddress * );
void		XAddHosts(			Display *, XHostAddress *, int );
void		XAddToSaveSet(			Display *, Window );
Status		XAllocColor(			Display *, Colormap, XColor * );
Status		XAllocColorCells(		Display *, Colormap, Bool, unsigned long *, unsigned int, unsigned long *, unsigned int );
Status		XAllocColorPlanes(		Display *, Colormap, Bool, unsigned long *, int, int, int, int, unsigned long *, unsigned long *, unsigned long * );
Status		XAllocNamedColor(		Display *, Colormap, char *, XColor *, XColor * );
void		XAllowEvents(			Display *, int, Time );
void		XAutoRepeatOn(			Display *  );
void		XAutoRepeatOff(			Display *  );
void		XBell(				Display *, int );
void		XChangeActivePointerGrab(	Display *, unsigned int, Cursor, Time );
void		XChangeGC(			Display *, GC, unsigned long, XGCValues * );
void		XChangeKeyboardControl(		Display *, unsigned long, XKeyboardControl * );
void		XChangeKeyboardMapping(		Display *, int, int, KeySym *, int );
void		XChangePointerControl(		Display *, Bool, Bool, int, int, int );
void		XChangeProperty(		Display *, Window, Atom, Atom, int, int, unsigned char *, int );
void		XChangeSaveSet(			Display *, Window, int );
void		XChangeWindowAttributes(	Display *, Window, unsigned long, XSetWindowAttributes * );
Bool		XCheckIfEvent(			Display *, XEvent *, Bool (*)( Display *, XEvent *, char * ), char * );
Bool		XCheckMaskEvent(		Display *, unsigned long, XEvent * );
Bool		XCheckTypedEvent(		Display *, int, XEvent * );
Bool		XCheckTypedWindowEvent(		Display *, Window, int, XEvent * );
Bool		XCheckWindowEvent(		Display *, Window, int, XEvent * );
void		XCirculateSubwindows(		Display *, Window, int );
void		XCirculateSubwindowsDown(	Display *, Window );
void		XCirculateSubwindowsUp(		Display *, Window );
void		XClearArea(			Display *, Window, int, int, unsigned int, unsigned int, Bool );
void		XClearWindow(			Display *, Window );
void		XClipBox(			Region,    XRectangle * );
void		XCloseDisplay(			Display *  );
void		XConfigureWindow(		Display *, Window, unsigned int, XWindowChanges * );
void		XConvertSelection(		Display *, Atom, Atom, Atom, Window, Time );
void		XCopyArea(			Display *, Drawable, Drawable, GC, int, int, unsigned int, unsigned int, int, int );
Colormap	XCopyColormapAndFree( 		Display *, Colormap );
void		XCopyGC(			Display *, GC, unsigned long, GC );
void		XCopyPlane(			Display *, Drawable, Drawable, GC, int, int, unsigned int, unsigned int, int, int, unsigned long );
Pixmap		XCreateBitmapFromData(		Display *, Drawable, char *, unsigned int, unsigned int );
Colormap	XCreateColormap(      		Display *, Window, Visual *, int );
Cursor		XCreateFontCursor(    		Display *, unsigned int );
GC		XCreateGC(	      		Display *, Drawable, unsigned long, XGCValues * );
Cursor		XCreateGlyphCursor(   		Display *, Font, Font, unsigned int, unsigned int, XColor *, XColor * );
XImage *	XCreateImage(			Display *, Visual *, unsigned int, int, int, char *, unsigned int, unsigned int, int, int );
Pixmap		XCreatePixmap(			Display *, Drawable, unsigned int,                   unsigned int, unsigned int );
Cursor		XCreatePixmapCursor(  		Display *, Pixmap, Pixmap, XColor *, XColor *,       unsigned int, unsigned int );
Pixmap		XCreatePixmapFromBitmapData(	Display *, Drawable, char *, unsigned int, unsigned int, unsigned long, unsigned long, unsigned int );
Region		XCreateRegion(			void       );
Window		XCreateSimpleWindow(		Display *, Window, int, int, unsigned int, unsigned int, unsigned int,  unsigned long, unsigned long );
Window		XCreateWindow(			Display *, Window, int, int, unsigned int, unsigned int, unsigned int,  int,           unsigned int, Visual *, unsigned long, XSetWindowAttributes * ); 
void		XDefineCursor(			Display *, Window, Cursor );
int		XDeleteContext(			Display *, Window, XContext );
XModifierKeymap	* 	XDeleteModifiermapEntry( 	XModifierKeymap *, KeyCode, int );
void		XDeleteProperty(		Display *, Window, Atom );
void		XDestroyRegion(			Region     );
void		XDestroySubwindows(		Display *, Window );
void		XDestroyWindow(			Display *, Window );
void		XDisableAccessControl(		Display *  );
char *		XDisplayName( 			char *     );
void		XDrawArc(			Display *, Drawable, GC, int, int, unsigned int, unsigned int, int, int );
void		XDrawArcs(			Display *, Drawable, GC, XArc *, int );
void		XDrawImageString(		Display *, Drawable, GC, int, int, char *, int );
void		XDrawImageString16(		Display *, Drawable, GC, int, int, XChar2b *, int );
void		XDrawLine( 			Display *, Drawable, GC, int, int, int, int );
void		XDrawLines(			Display *, Drawable, GC, XPoint *, int, int );
void		XDrawPoint(			Display *, Drawable, GC, int, int );
void		XDrawPoints(			Display *, Drawable, GC, XPoint *, int, int );
void		XDrawRectangle(			Display *, Drawable, GC, int, int, unsigned int, unsigned int );
void		XDrawRectangles(		Display *, Drawable, GC, XRectangle *, int );
void		XDrawSegments(			Display *, Drawable, GC, XSegment *, int );
void		XDrawString(			Display *, Drawable, GC, int, int, char *,    int );
void		XDrawString16(			Display *, Drawable, GC, int, int, XChar2b *, int );
void		XDrawText( 			Display *, Drawable, GC, int, int, XTextItem *,   int );
void		XDrawText16( 			Display *, Drawable, GC, int, int, XTextItem16 *, int );
int		XEmptyRegion(			Region     );
void		XEnableAccessControl(		Display *  );
int		XEqualRegion(			Region,    Region );
int		XEventsQueued(			Display *, int );
char *		XFetchBuffer( 			Display *, int *, int );
char *		XFetchBytes(  			Display *, int * );
Status		XFetchName(			Display *, Window, char ** );
void		XFillArc(			Display *, Drawable, GC, int, int, unsigned int, unsigned int, int, int );
void		XFillArcs(			Display *, Drawable, GC, XArc *, int );
void		XFillPolygon(			Display *, Drawable, GC, XPoint *, int, int, int );
void		XFillRectangle(			Display *, Drawable, GC, int, int, unsigned int, unsigned int );
void		XFillRectangles(		Display *, Drawable, GC, XRectangle *, int );
int		XFindContext(			Display *, Window, XContext, caddr_t * );
void		XFlush( 			Display *  );
void		XForceScreenSaver(		Display *, int );
void		XFree(				char *     );
void		XFreeColormap(			Display *, Colormap );
void		XFreeColors(			Display *, Colormap, unsigned long *, int, unsigned long );
void		XFreeCursor(			Display *, Cursor );
void		XFreeExtensionList(		char **    );
void		XFreeFont(			Display *, XFontStruct * );
void		XFreeFontInfo(			char **,   XFontStruct *, int );
void		XFreeFontNames(			char **    );
void		XFreeFontPath(			char **    );
void		XFreeGC(			Display *, GC );
void		XFreeModifiermap(		XModifierKeymap * );
void		XFreePixmap(			Display *, Pixmap );
GContext	XGContextFromGC(      		GC         );
int		XGeometry(			Display *, int, char *, char *, unsigned int, unsigned int, unsigned int, int, int, int *, int *, int *, int * );
char *		XGetAtomName( 			Display *, Atom );
Status		XGetClassHint(			Display *, Window, XClassHint * );
char *		XGetDefault(  			Display *, char *, char * );
void		XGetErrorDatabaseText(		Display *, char *, char *, char *, char *, int );
void		XGetErrorText(			Display *, int, char *, int );
char **		XGetFontPath(			Display *, int * );
Bool		XGetFontProperty(		XFontStruct *,Atom, unsigned long * ); 
Status		XGetGeometry(			Display *, Drawable, Window *, int *, int *, unsigned int *, unsigned int *, unsigned int *, unsigned int *);
Status		XGetIconName(			Display *, Window, char ** );
Status		XGetIconSizes(			Display *, Window, XIconSize **, int * );
XImage *	XGetImage(			Display *, Drawable, int, int, unsigned int, unsigned int, unsigned long, int );
void		XGetInputFocus(			Display *, Window *, int * );
void		XGetKeyboardControl(		Display *, XKeyboardState * );
KeySym *	XGetKeyboardMapping(		Display *, KeyCode, int, int * );
XModifierKeymap	*	XGetModifierMapping( 	Display * );
XTimeCoord *	XGetMotionEvents(   		Display *, Window, Time, Time, int * );
Status		XGetNormalHints(		Display *, Window, XSizeHints * );
void		XGetPointerControl(		Display *, int *, int *, int * );
int		XGetPointerMapping(		Display *, unsigned char *, int );
void		XGetScreenSaver(		Display *, int *, int *, int *, int * );
Window		XGetSelectionOwner(		Display *, Atom );
Status		XGetSizeHints(			Display *, Window, XSizeHints *, Atom );
Status		XGetStandardColormap(		Display *, Window, XStandardColormap *, Atom );
XImage *	XGetSubImage(			Display *, Drawable, int, int, unsigned int, unsigned int, unsigned long, int, XImage *, int, int );
Status		XGetTransientForHint(		Display *, Window, Window * );
XVisualInfo *	XGetVisualInfo(			Display *, long, XVisualInfo *, int * );
Status		XGetWindowAttributes(		Display *, Window, XWindowAttributes * );
int		XGetWindowProperty(		Display *, Window, Atom, long, long, Bool, Atom, Atom *, int *, unsigned long *, unsigned long *, unsigned char ** );
XWMHints *	XGetWMHints(			Display *, Window );
Status		XGetZoomHints(			Display *, Window, XSizeHints * );
void		XGrabButton(			Display *, unsigned int, unsigned int, Window, Bool, unsigned int, int, int, Window, Cursor );
void		XGrabKey(			Display *,          int, unsigned int, Window, Bool,               int, int );
int		XGrabKeyboard(			Display *, Window, Bool,               int, int,                 Time );
int		XGrabPointer(			Display *, Window, Bool, unsigned int, int, int, Window, Cursor, Time );
void		XGrabServer(			Display *  );
void		XIfEvent(			Display *, XEvent *, Bool (*)( Display *, XEvent *, char * ), char * );
XModifierKeymap	*	XInsertModifiermapEntry( 	XModifierKeymap *, KeyCode, int );
void		XInstallColormap(		Display *, Colormap );
Atom		XInternAtom( 	      		Display *, char *, Bool );
int		XIntersectRegion(		Region,    Region, Region );
KeySym		XKeycodeToKeysym(		Display *, KeyCode, int );
KeyCode		XKeysymToKeycode(		Display *, KeySym );
char *		XKeysymToString(		KeySym     );
void		XKillClient(			Display *, XID );
char **		XListExtensions(		Display *, int * );
char **		XListFonts(			Display *, char *, int, int * );
char **		XListFontsWithInfo(		Display *, char *, int, int *, XFontStruct ** );
XHostAddress *	XListHosts(			Display *, int *, Bool * );
Colormap *	XListInstalledColormaps(	Display *, Window, int * );
Atom *		XListProperties(		Display *, Window, int * );
Font		XLoadFont(	      		Display *, char * );
XFontStruct *	XLoadQueryFont( 		Display *, char * );
Status		XLookupColor(			Display *, Colormap, char *, XColor *, XColor * );
KeySym		XLookupKeysym(			XKeyEvent *, int );
int		XLookupString(			XKeyEvent *, char *, int, KeySym *, XComposeStatus * );
void		XLowerWindow(			Display *, Window );
void		XMapRaised(			Display *, Window );
void		XMapSubwindows(			Display *, Window );
void		XMapWindow(			Display *, Window );
void		XMaskEvent(			Display *, unsigned long, XEvent * );
Status		XMatchVisualInfo(		Display *, int, int, int, XVisualInfo * );
void		XMoveResizeWindow(		Display *, Window, int, int, unsigned int, unsigned int );
void		XMoveWindow(			Display *, Window, int, int );
XModifierKeymap *	XNewModifiermap( 	int        );
void		XNextEvent( 			Display *, XEvent * );
void		XNoOp(				Display *  );
void		XOffsetRegion(			Region,    int, int );    
Display	*	XOpenDisplay( 			char *     );
Status		XParseColor(			Display *, Colormap, char *, XColor * );
int		XParseGeometry(			char *,    int *, int *, unsigned int *, unsigned int * );
void		XPeekEvent(			Display *, XEvent * );
void		XPeekIfEvent(			Display *, XEvent *, Bool (*)( Display *, XEvent *, char * ), char * );
int		XPending(			Display *  );
int		XPointInRegion(			Region,    int, int );
Region		XPolygonRegion(			XPoint *,  int, int ); 
void		XPutBackEvent(			Display *, XEvent * );
void		XPutImage(			Display *, Drawable, GC, XImage *, int, int, int, int, unsigned int, unsigned int );
Status		XQueryBestColor(		Display *,      Drawable, unsigned int, unsigned int, unsigned int *, unsigned int * );
Status		XQueryBestSize(			Display *, int, Drawable, unsigned int, unsigned int, unsigned int *, unsigned int * );
Status		XQueryBestStipple(		Display *,      Drawable, unsigned int, unsigned int, unsigned int *, unsigned int * );
Status		XQueryBestTile(			Display *,      Drawable, unsigned int, unsigned int, unsigned int *, unsigned int * );
void		XQueryColor(			Display *, Colormap, XColor * );
void		XQueryColors(			Display *, Colormap, XColor *, int );
Bool		XQueryExtension(		Display *, char *, int *, int *, int * );
XFontStruct *	XQueryFont(     		Display *, XID );
void		XQueryKeymap(			Display *, char * );
Bool		XQueryPointer(			Display *, Window, Window *, Window *, int *, int *, int *, int *, unsigned int * );
void		XQueryTextExtents(		Display *, XID,    char *, int, int *, int *, int *, XCharStruct * );
void		XQueryTextExtents16(		Display *, XID, XChar2b *, int, int *, int *, int *, XCharStruct * );
Status		XQueryTree(			Display *, Window, Window *, Window *, Window **, unsigned int * );
void		XRaiseWindow(			Display *, Window );
int		XReadBitmapFile(		Display *, Drawable, char *, unsigned int *, unsigned int *, Pixmap *, int *, int * );
void		XRebindKeysym(			Display *, KeySym, KeySym *, int, unsigned char *, int );
void		XRecolorCursor(			Display *, Cursor, XColor *, XColor * );
int		XRectInRegion(			Region,    int, int, unsigned int, unsigned int );
void		XRefreshKeyboardMapping( 	XMappingEvent * );
void		XRemoveFromSaveSet(		Display *, Window );
void		XRemoveHost(			Display *, XHostAddress * );
void		XRemoveHosts(			Display *, XHostAddress *, int );
void		XReparentWindow(		Display *, Window, Window, int, int );
void		XResetScreenSaver(		Display *  );
void		XResizeWindow(			Display *, Window, unsigned int, unsigned int ); 
void		XRestackWindows(		Display *, Window *, int );
void		XRotateBuffers(			Display *, int );
void		XRotateWindowProperties(	Display *, Window, Atom *, int, int );
int		XSaveContext(			Display *, Window, XContext, caddr_t );
void		XSelectInput( 			Display *, Window, unsigned long );
Status		XSendEvent(			Display *, Window, Bool, unsigned long, XEvent * );
void		XSetAccessControl(		Display *, int );
int (*		XSetAfterFunction(  		Display *, int (*)( Display * ) ))( Display * );
void		XSetArcMode(			Display *, GC, int );
void		XSetBackground(			Display *, GC, unsigned long );
void		XSetClassHint(			Display *, Window, XClassHint * );
void		XSetClipMask(			Display *, GC, Pixmap );
void		XSetClipOrigin(			Display *, GC, int, int );
void		XSetClipRectangles(		Display *, GC, int, int, XRectangle *, int, int );
void		XSetCloseDownMode(		Display *, int );
void		XSetCommand(			Display *, Window, char **, int );
void		XSetDashes(			Display *, GC, int, char *, int );
void		XSetErrorHandler(		int (*)(   Display *, XErrorEvent * )  );
void		XSetFillRule(			Display *, GC, int );
void		XSetFillStyle(			Display *, GC, int );
void		XSetFont(			Display *, GC, Font );
void		XSetFontPath(			Display *, char **, int );
void		XSetForeground( 		Display *, GC, unsigned long );
void		XSetFunction(			Display *, GC, int );
void		XSetGraphicsExposures(		Display *, GC, Bool );
void		XSetIconName(			Display *, Window, char * );
void		XSetIconSizes(			Display *, Window, XIconSize *, int );
void		XSetInputFocus(			Display *, Window, int, Time );
void		XSetIOErrorHandler(		int (*     )( Display * ) );
void		XSetLineAttributes( 		Display *, GC, unsigned int, int, int, int );
int		XSetModifierMapping(		Display *, XModifierKeymap * );
void		XSetNormalHints(		Display *, Window, XSizeHints * );
void		XSetPlaneMask(			Display *, GC, unsigned long );
int		XSetPointerMapping(		Display *, unsigned char *, int );
void		XSetRegion(			Display *, GC, Region );
void		XSetScreenSaver(		Display *, int, int, int, int );
void		XSetSelectionOwner(		Display *, Atom, Window, Time );
void		XSetSizeHints(			Display *, Window, XSizeHints *, Atom );
void		XSetStandardColormap(		Display *, Window, XStandardColormap *, Atom );
void		XSetStandardProperties( 	Display *, Window, char *, char *, Pixmap, char **, int, XSizeHints * );
void		XSetState(			Display *, GC, unsigned long, unsigned long, int, unsigned long );
void		XSetStipple(			Display *, GC, Pixmap );
void		XSetSubwindowMode(		Display *, GC, int );
void		XSetTile(			Display *, GC, Pixmap );
void		XSetTransientForHint(		Display *, Window, Window );
void		XSetTSOrigin(			Display *, GC, int, int );
void		XSetWindowBackground(		Display *, Window, unsigned long );
void		XSetWindowBackgroundPixmap(	Display *, Window, Pixmap );
void		XSetWindowBorder(		Display *, Window, unsigned int );
void		XSetWindowBorderPixmap(		Display *, Window, Pixmap );
void		XSetWindowBorderWidth(		Display *, Window, unsigned int );
void		XSetWindowColormap(		Display *, Window, Colormap );
void		XSetWMHints(			Display *, Window, XWMHints * );
void		XSetZoomHints(			Display *, Window, XSizeHints * );
void		XShrinkRegion(			Region,    int, int );
void		XStoreBuffer(			Display *, char *, int,int );
void		XStoreBytes(			Display *, char *, int );
void		XStoreColor(			Display *, Colormap, XColor * );
void		XStoreColors(			Display *, Colormap, XColor *, int );
KeySym		XStringToKeysym(		char *     );
void		XStoreName(			Display *, Window, char * );
void		XStoreNamedColor(		Display *, Colormap, char *, unsigned long, int );
KeySym		XStringToKeysym(		char *     );
void		XSubtractRegion(		Region,    Region, Region );
void		XSync( 				Display *, int );
int (*		XSynchronize(       		Display *, int ))( Display * );
void		XTextExtents(			XFontStruct *, char *,    int, int *, int *, int *, XCharStruct * );
void		XTextExtents16(			XFontStruct *, XChar2b *, int, int *, int *, int *, XCharStruct * );
int		XTextWidth(			XFontStruct *, char *,    int );
int		XTextWidth16(			XFontStruct *, XChar2b *, int );
int		XTranslateCoordinates(		Display *, Window, Window, int, int, int *, int *, Window * );
void		XUndefineCursor(		Display *, Window );
void		XUngrabButton(			Display *, unsigned int, unsigned int, Window );
void		XUngrabKey(			Display *,          int, unsigned int, Window );
void		XUngrabKeyboard(		Display *, Time );
void		XUngrabPointer(			Display *, Time );
void		XUngrabServer(			Display *  );
void		XUninstallColormap(		Display *, Colormap );
void		XUnionRectWithRegion(		XRectangle *, Region, Region );
void		XUnionRegion(			Region,    Region, Region );
void		XUnloadFont(			Display *, Font );
void		XUnmapSubwindows(		Display *, Window );
void		XUnmapWindow( 			Display	*, Window );
Status		XWarpPointer(			Display *, Window, Window, int, int, unsigned int, unsigned int, int, int );
void		XWindowEvent(			Display *, Window, long, XEvent * );
int		XWriteBitmapFile(		Display *, char *, Pixmap, unsigned int, unsigned int, int, int );
void		XXorRegion(			Region,    Region, Region );

/*
 * routines for dealing with extensions
 */

XExtCodes *	XInitExtension(			Display *, char * );
int (*		XESetCloseDisplay(		Display *, int, int (*)(  Display *,                XExtCodes * ) ))        ( Display *,                XExtCodes * );
int (*		XESetCopyGC(			Display *, int, int (*)(  Display *, GC,            XExtCodes * ) ))        ( Display *, GC,            XExtCodes * );
int (*		XESetCreateFont(		Display *, int, int (*)(  Display *, XFontStruct *, XExtCodes * ) ))        ( Display *, XFontStruct *, XExtCodes * );
int (*		XESetCreateGC(			Display *, int, int (*)(  Display *, GC,            XExtCodes * ) ))        ( Display *, GC,            XExtCodes * );
char (*		XESetErrorString(		Display *, int, char (*)( Display *, int,           XExtCodes * ) ))        ( Display *, int,           XExtCodes * );
int (*		XESetFlushGC(			Display *, int, int (*)(  Display *, GC,            XExtCodes * ) ))        ( Display *, GC,            XExtCodes * );
int (*		XESetFreeGC(			Display *, int, int (*)(  Display *, GC,            XExtCodes * ) ))        ( Display *, GC,            XExtCodes * );
int (*		XESetFreeFont(			Display *, int, int (*)(  Display *, XFontStruct *, XExtCodes * ) ))        ( Display *, XFontStruct *, XExtCodes * );

#ifdef XPROTO_H

int (*		XESetError(			Display *, int, int (*)(  Display *, xError *,      XExtCodes *, int * ) )) ( Display *, xError *,      XExtCodes *, int * );

#ifdef NEED_EVENTS

Status (*	XESetEventToWire(		Display *, int, int (*)(  Display *, XEvent *,      xEvent ) ))             ( Display *, XEvent *,      xEvent );
Bool (*		XESetWireToEvent(		Display *, int, Bool (*)( Display *, XEvent *,      xEvent ) ))             ( Display *, XEvent *,      xEvent );

#endif

#endif

/* these are routines for which there are also macros */

unsigned long	XAllPlanes(			void );
unsigned long	XBlackPixel(			Display *, int );
unsigned long	XBlackPixelOfScreen(		Screen * );
Colormap	XDefaultColormap(		Display *, int );
Colormap	XDefaultColormapOfScreen(	Screen * );
int		XDefaultDepth(			Display *, int );
GC		XDefaultGC(			Display *, int );
GC		XDefaultGCofScreen(		Screen * );
Window		XDefaultRootWindow(		Display * );
int		XDefaultScreen(			Display * );
Screen *	XDefaultScreenOfDisplay(	Display * );
Visual *	XDefaultVisual(			Display *, int );
Visual *	XDefaultVisualOfScreen(		Screen * );
Display	*	XDisplayOfScreen(		Screen * );
char *		XDisplayString(			Display * );
long		XEventMaskOfScreen(		Screen * );
unsigned long	XLastKnownRequestProcessed(	Display * );
unsigned long	XNextRequest(			Display * );
Window		XRootWindow(			Display *, int );
Window		XRootWindowOfScreen(		Screen * );
Screen *	XScreenOfDisplay(		Display *, int );
char *		XServerVendor(			Display * );
unsigned long	XWhitePixel(			Display *, int );
unsigned long	XWhitePixelOfScreen(		Screen * );

#endif /* _XLIB_H_ */

